///////////////////////////////////////////////////////////////
// File Name: iosystem.h
// Purpose:  Definition of the io subsystems
///////////////////////////////////////////////////////////////

#ifndef IOSYSTEM_H
#define IOSYSTEM_H

#include "systems.h"
#include "basetypes.h"

class HandshakeIOSubSystem : public HC11SubSystem
{	
 protected:
 
 // Registers (in HC11::regfile)
	HC11* hc11;
    byte_t STRB_pulse;

 //	Functions
 public:

    void WriteToPORTB(void);
 
    HandshakeIOSubSystem (HC11 * nhc11);
	void ClockSystem(void);
};

#endif
