// AssembleDlg.cpp : implementation file
//

#include "stdafx.h"
#include "HardCoreWookie.h"
#include "AssembleDlg.h"
#include <direct.h>

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAssembleDlg dialog


CAssembleDlg::CAssembleDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CAssembleDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CAssembleDlg)
	//}}AFX_DATA_INIT
}


void CAssembleDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAssembleDlg)
	DDX_Control(pDX, IDC_S19NAME, m_s19name);
	DDX_Control(pDX, IDC_NERRORS, m_nerrors);
	DDX_Control(pDX, IDC_LSTNAME, m_lstname);
	DDX_Control(pDX, IDC_ASMNAME, m_asmname);
	DDX_Control(pDX, IDC_BUTTON1, m_go);
	DDX_Control(pDX, IDC_EDIT1, m_edit);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CAssembleDlg, CDialog)
	//{{AFX_MSG_MAP(CAssembleDlg)
	ON_BN_CLICKED(IDC_BUTTON1, OnGo)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CAssembleDlg message handlers

extern int as11m_main(int argc,char **argv, FILE *of, FILE *lstf);

void CAssembleDlg::OnGo() 
{	
	CString bigbuffer;
	char littlebuffer[101];
	int len, status;
	
	int index=asmfile.GetLength()-1;
	while(asmfile.GetAt(index) != '\\')index--;
	index = asmfile.Find(".");

	CString filename = asmfile.Left(index);
	CString s19filename = filename + ".s19";
	CString lstfilename = filename + ".lst";	

	FILE *lstfile=fopen(lstfilename.GetBuffer(0), "wb");
	if(!lstfile)
	{
		AfxMessageBox("could not create .lst file");
		return;
	}

	FILE *s19file=fopen(s19filename.GetBuffer(0), "wb");
	if(!s19file)
	{
		fclose(lstfile);
		AfxMessageBox("could not create .s19 file");
		return;
	}
	

	char **asm_files = new char*[1];
	(*asm_files) = new char[asmfile.GetLength()+1];
	strcpy(asm_files[0], asmfile.GetBuffer(0));
	
	status = as11m_main(1, asm_files, s19file, lstfile);

	delete (*asm_files);
	delete asm_files;
	fclose(lstfile);
	fclose(s19file);

	m_s19name.SetWindowText(s19filename);
	m_lstname.SetWindowText(lstfilename);

	CString errstr;
	errstr.Format("%d", status);
	m_nerrors.SetWindowText(errstr);

	if(status)	
		AfxMessageBox("errors found\n");
	

	lstfile=fopen(lstfilename.GetBuffer(0), "rb");
	if (lstfile != NULL)
    {		 	
        // Read in from the lst file passed in as a parameter
	    while (!feof(lstfile))
	    {
		    len = fread(littlebuffer,1,sizeof(littlebuffer)-2,lstfile);		
			bigbuffer += littlebuffer;
	    }       
        // Display lst file in the code view window
	    m_edit.SetWindowText(bigbuffer);
        fclose(lstfile);	
    }	
}

BOOL CAssembleDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	m_asmname.SetWindowText(asmfile);
	
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}
